package com.yeejoin.amos.boot.module.common.biz.controller;

import java.util.List;

import com.yeejoin.amos.boot.module.common.api.entity.FailureAudit;
import com.yeejoin.amos.boot.module.common.api.entity.FailureMaintain;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.typroject.tyboot.core.foundation.enumeration.UserType;
import org.typroject.tyboot.core.restful.doc.TycloudOperation;
import org.typroject.tyboot.core.restful.utils.ResponseHelper;
import org.typroject.tyboot.core.restful.utils.ResponseModel;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yeejoin.amos.boot.biz.common.controller.BaseController;
import com.yeejoin.amos.boot.module.common.api.dto.FailureMaintainDto;
import com.yeejoin.amos.boot.module.common.biz.service.impl.FailureMaintainServiceImpl;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * 
 *
 * @author system_generator
 * @date 2021-08-04
 */
@RestController
@Api(tags = "故障维修记录Api")
@RequestMapping(value = "/common/failure-maintain")
public class FailureMaintainController extends BaseController {

    @Autowired
    FailureMaintainServiceImpl failureMaintainServiceImpl;

    /**
     * 新增
     *
     * @return
     */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
	@PostMapping(value = "/save")
	@ApiOperation(httpMethod = "POST", value = "新增", notes = "新增")
	public ResponseModel<Object> save(@RequestBody FailureMaintainDto model)  {

		try {
			return ResponseHelper.buildResponse(failureMaintainServiceImpl.savemodel(model,getSelectedOrgInfo()));
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseHelper.buildResponse(false);
		}
	}

	/**
     * 根据sequenceNbr更新
	 * 根据传递的Status状态确认验收状态
     *
     *
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@PutMapping(value = "/verify")
	@ApiOperation(httpMethod = "PUT", value = "验收操作", notes = "根据sequenceNbr更新")
	public Object updateBySequenceNbrFailureMaintain(@RequestBody FailureMaintainDto model) {
		try {
			return ResponseHelper.buildResponse(failureMaintainServiceImpl.updateModel(model,getSelectedOrgInfo()));
		} catch (Exception e) {
			e.printStackTrace();
			return ResponseHelper.buildResponse(false);
		}
	}


/*
	*/
/**
	 * 根据sequenceNbr更新
	 * 根据传递的Status状态确认验收状态
	 *
	 * @param sequenceNbr 主键
	 * @return
	 *//*

	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@PutMapping(value = "/update/{sequenceNbr}")
	@ApiOperation(httpMethod = "PUT", value = "维修完成", notes = "根据sequenceNbr更新")
	public Object updateByFailureMaintain(@RequestBody FailureMaintainDto model,@PathVariable(value = "sequenceNbr") Long sequenceNbr)  {
		model.setSequenceNbr(sequenceNbr);

		try {
			return ResponseHelper.buildResponse(failureMaintainServiceImpl.updateStatus(model,getSelectedOrgInfo()));
		} catch (Exception e) {
			return ResponseHelper.buildResponse(false);
		}
	}
*/



	/**
     * 列表分页查询
     *
     * @param current 当前页
     * @param current 每页大小
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/page")
	@ApiOperation(httpMethod = "GET",value = "分页查询",  notes = "分页查询")
	public ResponseModel<Page<FailureMaintainDto>> queryForPage(@RequestParam(value = "current") int current,@RequestParam
                    (value = "size") int size) {
	    Page<FailureMaintainDto> page = new Page<FailureMaintainDto>();
	    page.setCurrent(current);
	    page.setSize(size);
	    return ResponseHelper.buildResponse(failureMaintainServiceImpl.queryForFailureMaintainPage(page));
	}


	/**
	 * 维修列表记录查询
	 *根据关联主表faultId查询
	 * @return
	 */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@ApiOperation(httpMethod = "GET",value = "维修列表记录查询",   notes = "维修列表记录查询")
	@GetMapping(value = "/list/{faultId}")
	public ResponseModel<List<FailureMaintain>> findByFaultIDFotList(@PathVariable long faultId) {
		return ResponseHelper.buildResponse(failureMaintainServiceImpl.findByfaultId(faultId));
	}




	/**
	 * 查询历史流程审核信息记录
     *
	 * @return
	 */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@ApiOperation(httpMethod = "GET",value = "设备故障报修单详情-报修日志",   notes = "设备故障报修单详情-报修日志")
	@GetMapping(value = "/getProcessHistory/{sequenceNbr}")
	public ResponseModel<List<Object>> getProcessHistory(@PathVariable Long sequenceNbr ) {
	    return ResponseHelper.buildResponse(failureMaintainServiceImpl.getProcessHistoryList(sequenceNbr));
	}
}
